.ds Pg \fBPostgres\fR
.ds P4 \fBPostgres V4.2\fR
.ds P9 \fBPostgres95\fR
.ds Pm \fBPostmaster\fR
.ds pm \fBpostmaster\fR
.ds ms n
.\"
.\" ---------------------------------------------------------------------
.\"
.TH pqa_status \*(ms "Asynchronous Tcl/Postgres interface" "June 1996" "Pqa package for Tcl/Tk"
.nh
.\"
.\" ---------------------------------------------------------------------
.\"
.SH NAME
pqa_status \- Get information about a database connection
.\"
.\" ---------------------------------------------------------------------
.\"
.SH SYNOPSIS
\fBpqa_status \fIconn option\fR
.\"
.\" ---------------------------------------------------------------------
.\"
.SH DESCRIPTION
.PP
.B Pqa_status(\*(ms)
returns status- and other information about an existing database
connection.
.\"
.\" ---------------------------------------------------------------------
.\"
.SH ARGUMENTS
.IP "\fIconn\fR" 6.0c
Specifies the database connection to return information about. 
The value must be
a valid connection identifier returned by a previous call of
\fBpqa_connect(\*(ms)\fR.
.\"
.\" ---------------------------------------------------------------------
.\"
.SH OPTIONS
.IP "\fB-status\fR" 6.0c
Returns one of '\fBidle\fR', '\fBbusy\fR' or '\fBlost\fR', giving
the current status of the connection. If the return value is '\fBlost\fR',
subsequent queries or large object operations will be refused.

.IP "\fB-results\fR" 6.0c
Returns a list of all valid result buffers available for this
connection.

.IP "\fB-version\fR" 6.0c
Returns '\fBV4.2\fR' or '\fBV95\fR' as magic strings about
the database version guessed by \fBpqa_connect(\*(ms)\fR.

.\"
.\" ---------------------------------------------------------------------
.\"
.SH RETURN VALUE
.PP
.B Pqa_status(\*(ms)
returns the requested information
or an error if the connection identifier is invalid.
.\"
.\" ---------------------------------------------------------------------
.\"
.SH SEE ALSO
.PP
pqa_connect(\*(ms), 
postgres(1), postmaster(1)
